{$I-} {$A+} {$R-} {$S-} {$Q-} {$G+} {$N+} {$E-} {$D+} {$L-} {$Y-} {$X-}
Program LGLTest;
Uses
    LGLInt, LGL, LRF, LUtils, LMem, LInput, BSound, Objects, Memory, DOS;
Const
    cFPS = 24;
    cSkipT = 1000 Div cFPS;
    cFLen = 8;
Var
    GScrP: TScreenP;
    GPalP: TPaletteP;
    Lab1, Lab2, Lab3, Lab4, Lab5, Lab6, Lab7, Lab8: TLabelP;
    BG1, BG2, BG3, WGS, Duck: TImageP;
    PPD, TSR, DJ, MAF, AJ, FS, RAR, RD, TSB, Temp: TAnimP;
    FontP: TFontP;
    IsTW: Boolean;
    ResP: TResP;
    I, II: Integer;
    GNGT, GST: LongInt;
    FSS: TDosStream;
    MS: TEmsStream;
    IsFPS: Boolean;

Procedure ProcessDelay(ASkipT: Word);
Var
    CurMS: LongInt;
Begin
    CurMS:= ReadMS;
    Inc(GNGT, ASkipT);
    GST:= GNGT - CurMS;
    If (GST > 1000000) Or (GST < 0) Then Begin
      GNGT:= CurMS; GST:= 0;
    End
    Else If GST > 0 Then Delay(GST);
End;

Const
    cStartXP = 128; CStartYP = 80; cRatio = 320 / 200;
Var
    FlipA: Array [1..50] Of Integer; FAI: Integer;
    AOrder: Array [1..12] Of TAnimP;
    RW, RH, RXP, RYP: Real;
    W, H, XP, YP, LI, III, TI, TWH: Integer;
    Sc, Sc2: LGL.TImgP;
    FD: Text;
    IsF: Boolean;
Begin
    IsFPS:= ParamStr(1) <> '';
    InitMemory;
    SoundRepeat:= False;
    FSS.Init('hshake.wav', StOpenRead);
    MS.Init(FSS.GetSize, FSS.GetSize);
    MS.CopyFrom(FSS, FSS.GetSize);
    FSS.Done;
    MS.Seek(0);
    If InitSound(@MS) <> BSOk Then;

    SetNewKeybHandler;
    Set32BitDrawMode(True);
    Set32BitRefreshMode(True);

    New(GScrP, Create(False));
    GScrP^.InitGM;

    CreateRes(ResP);
    OpenRF(ResP, 'res.lrf');
    New(FontP, LoadFromRes(ResP, 'base.lff'));
    New(GPalP, LoadFromRes(ResP, 'pal.lpf'));
    New(GScrP^.FPalP, Create);
    New(BG1, LoadFromRes(ResP, 'bg3.lgf'));
    New(PPD, LoadFromRes(ResP, 'ppd', '.lgf', 8));
    New(TSR, LoadFromRes(ResP, 'tsr', '.lgf', 28));
    New(DJ, LoadFromRes(ResP, 'dj', '.lgf', 10));
    New(MAF, LoadFromRes(ResP, 'maf', '.lgf', 2));
    New(AJ, LoadFromRes(ResP, 'aj', '.lgf', 17));
    New(FS, LoadFromRes(ResP, 'fs', '.lgf', 34));
    New(RAR, LoadFromRes(ResP, 'rar', '.lgf', 2));
    New(TSB, LoadFromRes(ResP, 'tsb', '.lgf', 30));
    New(RD, LoadFromRes(ResP, 'rd', '.lgf', 6));
    New(Duck, LoadFromRes(ResP, 'duck.lgf'));

    New(Lab1, Create(FontP, 'CREDITS'));
    New(Lab2, Create(FontP, 'ORIGINAL SONG: BAAUER'));
    New(Lab3, Create(FontP, '8-BIT VERSION - KARLROLSON - '));
    New(Lab4, Create(FontP, 'SPRITES - DESKTOP PONIES TEAM'));
    New(Lab5, Create(FontP, 'CODE & IDEA - ABADUABER'));
    New(Lab6, Create(FontP, 'SOUND CODE - ALEXANDER PESLYAK'));
    New(Lab7, Create(FontP, 'THANKS - JT137, RUBBER DUCK, PONIES, IFORUM.PRO, YOU'));
    New(Lab8, Create(FontP, '4F 46 21 57 4A 46 43 4A 57 42 5A 54 4A 42 2F'));

    PPD^.SetAllFrameDelay(1); PPD^.SetFlip(True, False);
    TSR^.SetAllFrameDelay(1);
    TSR^.SetFrameDelay(7, 50); TSR^.SetFrameDelay(13, 50);
    TSR^.SetFrameDelay(1, 50);
    DJ^.SetAllFrameDelay(1); AJ^.SetAllFrameDelay(1);
    MAF^.SetAllFrameDelay(2); FS^.SetAllFrameDelay(1);
    RAR^.SetAllFrameDelay(1); TSB^.SetAllFrameDelay(0);
    RD^.SetAllFrameDelay(1);

    GScrP^.FPalP^.SetRange(0, GPalP, 0, 255);
    GScrP^.FPalP^.Apply;
    GST:= 0;
    PPD^.MoveTo(128, 63); TSR^.MoveTo(45, 93);


    RW:= 64; RH:= 40; RXP:= 128; RYP:= 80;
    IsF:= False;
    Assign(FD, 'pf.txt');
    Reset(FD);
    FAI:= 1;
    While Not EOF(FD) Do Begin
      ReadLn(FD, FlipA[FAI]); Inc(FAI);
    End;
    LI:= 1; FAI:= 1;
    While Not IsKeyPressed(TKB_Enter) Do;
    Sc2:= LGL.Create(OT_Img, 320, 200);
    StartSound;
    Delay(12);
    While True Do Begin

        BG1^.Draw;
        PPD^.Draw;
        TSR^.Draw;
        If RH < 200 Then Begin
        W:= Trunc(RW); H:= Trunc(RH); XP:= Trunc(RXP); YP:= Trunc(RYP);
        Sc:= LGL.Create(OT_Img, W, H);
        LGL.CopyImg(Sc, GScrP^.GetImgP, XP, YP, W, H, 0, 0);
        LGL.ResizeImg(Sc2, Sc);
        LGL.Draw(Sc2, 0, 0);
        Sc:= LGL.Destroy(Sc);
        End;

        If II Mod 3 = 0 Then Begin
        If XP > 0 Then Begin
          RXP:= RXP - cRatio; If RXP < 0 Then RXP:= 0;
          RW:= RW + cRatio * 2; If RW > 320 Then RW:= 320;
        End;
        If YP > 0 Then Begin
          RYP:= RYP - 1; If RYP < 0 Then RYP:= 0;
          RH:= RH + 2; If RH > 200 Then RH:= 200;
        End;
        End;

        If IsKeyPressed(TKB_Esc) Then Break;
        If IsKeyPressed(TKB_Enter) Then GScrP^.SaveBMP(IntToStr(II) + '.bmp');
        If IsKeyPressed(TKB_Space) And (II > LI + 3) Then Begin
          WriteLn(FD, II);
          LI:= II;
        End;

        If II = FlipA[FAI] Then Begin
          Inc(FAI); IsF:= Not IsF;
        End;

        If II > 320 Then Begin
          If Not GScrP^.FPalP^.ChangeBr(2) Then
            GScrP^.FPalP^.Apply
          Else
            Break;
        End;

        If IsF Then GScrP^.SetFlip(Not GScrP^.IsHorFlip, False);

        If IsFPS Then FontP^.PrintXY('FPS: ' + IntToStr(GScrP^.GetFPS), 10, 10);

        GScrP^.Refresh;
        ProcessDelay(cSkipT);
        Inc(II);
    End;

    New(BG2, LoadFromRes(ResP, 'bg2.lgf'));
    New(BG3, LoadFromRes(ResP, 'bg1.lgf'));
    BG3^.MoveTo(0, 0); BG2^.MoveTo(320, 0);
    TSR^.MoveTo(280, 130); DJ^.MoveTo(200, 140); MAF^.MoveTo(162, 161);
    PPD^.MoveTo(40 + Random(200), Random(20) + 120);
    AJ^.MoveTo(350, 130); RD^.MoveTo(TSR^.Left + 3, 15);
    FS^.MoveTo(440, 135); RAR^.MoveTo(45, 115);
    RAR^.SetFlip(True, False);

    AOrder[1]:= TSR; AOrder[2]:= DJ; AOrder[3]:= MAF; AOrder[4]:= PPD;
    AOrder[5]:= AJ; AOrder[6]:= RD; AOrder[7]:= FS; AOrder[8]:= RAR;
    While True Do Begin
        For TI:= 1 To 7 Do Begin
          For III:= 1 To 8 - TI Do Begin
            If AOrder[III]^.Bottom > AOrder[III + 1]^.Bottom Then Begin
              Temp:= AOrder[III]; AOrder[III]:= AOrder[III + 1];
              AOrder[III + 1]:= Temp;
            End;
          End;
        End;

        BG2^.Move(-1, 0); BG3^.Move(-1, 0);
        BG2^.Draw; BG3^.Draw;
        For TI:= 1 To 8 Do Begin
          AOrder[TI]^.Move(-1, 0);
          AOrder[TI]^.Draw;
        End;

        If II Mod 20 = 0 Then Begin
          PPD^.MoveTo(40 + Random(240), Random(20) + 120);
          PPD^.SetFlip(Random(2) = 1, False);
        End;

        If IsKeyPressed(TKB_Esc) Then Break;
        If IsKeyPressed(TKB_Enter) Then GScrP^.SaveBMP(IntToStr(II) + '.bmp');

        If IsFPS Then FontP^.PrintXY('FPS: ' + IntToStr(GScrP^.GetFPS), 10, 10);
        GScrP^.Refresh;

        If II > 530 Then Begin
          If Not GScrP^.FPalP^.ChangeBr(-2) Then
            GScrP^.FPalP^.Apply
          Else
            Break;
        End
        Else If Not GScrP^.FPalP^.FadeTo(GPalP, -2) Then GScrP^.FPalP^.Apply;

        ProcessDelay(cSkipT);
        Inc(II);
    End;

        Lab1^.MoveTo(0, 30); Lab2^.MoveTo(0, 50);
        Lab3^.MoveTo(0, 60); Lab4^.MoveTo(0, 70);
        Lab5^.MoveTo(0, 80); Lab6^.MoveTo(0, 90);
        Lab7^.MoveTo(0, 100); Lab8^.MoveTo(0, 110);
        Duck^.MoveTo(0, 130);
        Lab1^.SetColor(255); Lab2^.SetColor(74);
        Lab3^.SetColor(33); Lab4^.SetColor(21);
        Lab5^.SetColor(235); Lab6^.SetCOlor(215);
        Lab7^.SetColor(205); Lab8^.SetColor(255);
        Lab1^.Align(THA_Center, TVA_None);
        Lab2^.Align(THA_Center, TVA_None);
        Lab3^.Align(THA_Center, TVA_None);
        Lab4^.Align(THA_Center, TVA_None);
        Lab5^.Align(THA_Center, TVA_None);
        Lab6^.Align(THA_Center, TVA_None);
        Lab7^.Align(THA_Center, TVA_None);
        Lab8^.Align(THA_Center, TVA_None);
        Duck^.Align(THA_Center, TVA_None);

    Sc:= LGL.Destroy(Sc); Sc2:= LGL.Destroy(Sc2);
    LI:= II; H:= 0; Temp:= DJ; TWH:= 150;                           {AJ RD RAR PPD FS}
    While Not IsKeyPressed(TKB_Esc) Do Begin
      If II = LI + cFLen Then Begin Temp:= TSR; H:= 0; End
      Else If II = LI + cFLen * 2 Then Begin Temp:= AJ; H:= 0; End
      Else If II = LI + cFLen * 3 Then Begin Temp:= TSR; H:= 0; End
      Else If II = LI + cFLen * 4 Then Begin Temp:= RD; H:= 0; End
      Else If II = LI + cFLen * 5 Then Begin Temp:= TSR; H:= 0; End
      Else If II = LI + cFLen * 6 Then Begin Temp:= RAR; H:= 0; End
      Else If II = LI + cFLen * 7 Then Begin Temp:= TSR; H:= 0; End
      Else If II = LI + cFLen * 8 Then Begin Temp:= PPD; H:= 0; End
      Else If II = LI + cFLen * 9 Then Begin Temp:= TSR; H:= 0; End
      Else If II = LI + cFLen * 10 Then Begin Temp:= FS; H:= 0; End
      Else If II = LI + cFLen * 11 Then Begin Temp:= TSR; H:= 0; End
      Else If II = LI + cFLen * 12 Then Begin Temp:= TSB; H:= 0; End
      Else If II > LI + cFLen * 17 Then Begin
        If Not GScrP^.FPalP^.ChangeBr(4) Then GScrP^.FPalP^.Apply
        Else Break;
      End;
      GScrP^.Fill(0);

      If II < LI + cFLen * 17 Then Begin
      If Not GScrP^.FPalP^.FadeTo(GPalP, 2) Then GScrP^.FPalP^.Apply;
      End;
      Inc(H);

      W:= Temp^.Width; If W < Temp^.Height Then W:= Temp^.Height;
      If Temp = TSB Then Begin
        W:= 100;
      End
      Else If Temp = TSR Then Begin
        W:= TWH;
        Inc(TWH);
      End
      Else
        W:= Trunc((160 / W) * 100 + H * 2);
      Temp^.SetAllFrameDelay(1);
      If W = 100 Then Begin
          Temp^.Align(THA_Center, TVA_Center);
          Temp^.Draw;
      End
      Else If Temp^.IsResizeDone(W, W) Then Begin
          Temp^.Hide;
          Temp^.Draw;
          Temp^.Show;
          Temp^.Trans^.Align(THA_Center, TVA_Center);
          Temp^.Trans^.Draw;
          Temp^.Trans^.Unload;
      End;
      Inc(II);
      GScrP^.Refresh;
      ProcessDelay(cSkipT);
    End;

    While Not IsKeyPressed(TKB_Esc) Do Begin
      If Not GScrP^.FPalP^.FadeTo(GPalP, -1) Then
        GScrP^.FPalP^.Apply
      Else Break;
      GScrP^.Fill(0);
      Lab1^.Draw; Lab2^.Draw; Lab3^.Draw; Lab4^.Draw; Lab5^.Draw;
      Lab6^.Draw; Lab7^.Draw; Lab8^.Draw; Duck^.Draw;

      Inc(II);
      If II > 1000 Then Break;
      GScrP^.Refresh;
      ProcessDelay(cSkipT);
    End;

    While Not IsKeyPressed(TKB_Esc) Do Begin
      If Not GScrP^.FPalP^.ChangeBr(-1) Then
        GScrP^.FPalP^.Apply
      Else Break;
      GScrP^.Fill(0);
      Lab1^.Draw; Lab2^.Draw; Lab3^.Draw; Lab4^.Draw; Lab5^.Draw;
      Lab6^.Draw; Lab7^.Draw; Lab8^.Draw; Duck^.Draw;

      Inc(II);
      If II > 1200 Then Break;
      GScrP^.Refresh;
      ProcessDelay(cSkipT);
    End;
    {      }

    Close(FD);
    Sc2:= LGL.Destroy(Sc2);
    StopSound;
    MS.Done;
    DoneMemory;


    DestroyRes(ResP);
    Dispose(FontP, Destroy);
    Dispose(GScrP, Destroy);
    Dispose(BG1, Destroy);
    Dispose(BG2, Destroy);
    Dispose(TSR, Destroy);
    Dispose(DJ, Destroy);
    Dispose(MAF, Destroy);
    Dispose(AJ, Destroy);
    Dispose(FS, Destroy);
    Dispose(RAR, Destroy);
    Dispose(TSB, Destroy);
    Dispose(RD, Destroy);

    RestoreOldKeybHandler;
End.
